# SPDX-FileCopyrightText: 2019, 2021 Freemelt AB <opensource@freemelt.com>
#
# SPDX-License-Identifier: GPL-3.0-only

variables:
  GIT_SUBMODULE_STRATEGY: recursive

stages:
  - license
  - build
  - test
  - deploy

build:bullseye: &build_template
  image: registry.gitlab.com/freemelt/supporting-systems/debdeploy:common-ci-bullseye
  stage: build
  script:
    - make deb-ci
    - make deb
  artifacts:
    paths:
      - "freemelt-metricsrelay-*.tar.xz"
      - "freemelt-metricsrelay*.deb"
      - "freemelt-metricsrelay_*.debian.tar.xz"
      - "freemelt-metricsrelay_*.dsc"
      - "freemelt-metricsrelay_*.changes"
      - "freemelt-metricsrelay_*.buildinfo"

build:bookworm_amd64:
  <<: *build_template
  before_script:
    - apt update --allow-releaseinfo-change
    - apt -y --no-install-recommends install golang-github-influxdb-influxdb-dev
  image: registry.gitlab.com/freemelt/supporting-systems/debdeploy:common-ci-bookworm

build:bookworm_arm64:
  <<: *build_template
  image: registry.gitlab.com/freemelt/supporting-systems/debdeploy:common-ci-bookworm
  variables:
    DEB_BUILD_PROFILES: cross
    CONFIG_SITE: /etc/dpkg-cross/cross-config.arm64
    DEB_BUILD_ARCH: arm64
  before_script:
    - dpkg --add-architecture arm64
    - apt update --allow-releaseinfo-change
    - apt -y --no-install-recommends install crossbuild-essential-arm64 libc6:arm64 build-essential debhelper-compat dh-golang golang-github-eclipse-paho.mqtt.golang-dev golang golang-github-influxdb-influxdb-dev

test:
  image: registry.gitlab.com/freemelt/supporting-systems/debdeploy:common-ci-bullseye
  stage: test
  script:
    - "dpkg -i freemelt-metricsrelay_*deb11*amd64.deb"

debdeploy:
  stage: deploy
  image: registry.gitlab.com/freemelt/supporting-systems/debdeploy:bookworm
  script:
    - /deploy

reuse:
  stage: license
  image:
    name: fsfe/reuse:latest
    entrypoint: [""]
  script:
    - reuse lint
